clc
clear
format long
a=3.61; %lattice constant for Cu
mu=0.35;
b = a/sqrt(6); %partial Burgers vector magnitude
zilp=a/(2*sqrt(3)*(1-mu)); %Leading partial core-width
zitp=a/(2*sqrt(3)*(1-mu)); %Trailing partial core-width
d=18*a/sqrt(3); %Stacking fault width
gamma_isf=41; %in mj/m^2
gamma_us=242; %in mj/m^2
a_prime=b; %Periodicity

i=1;
j=1;


term1=zeros(2001,1); %store misfit summation
f=zeros(1,2001); %store disregistry

%start displacing and calculating misfit
for u=0:0.0005*b:b
for m=-1000:1:1000
    
    
x=m*a_prime-u;

%disregistry function for extended dislocation
f(i)=b+b/pi*(atan((x+0.5*d)/zilp)+atan((x-0.5*d)/zitp));


if f(i)>=0 && f(i)<=0.5*b
term1(j)=term1(j)+gamma_us/2*(1-cos(2*pi*f(i)/b))*a_prime;
end
if f(i)>0.5*b && f(i)<=b

term1(j)=term1(j)+(gamma_isf+(gamma_us-gamma_isf)/2*(1-cos(2*pi*f(i)/b)))*a_prime;

end

if f(i)>b && f(i)<=1.5*b

term1(j)=term1(j)+(gamma_isf+(gamma_us-gamma_isf)/2*(1-cos(2*pi*f(i)/b)))*a_prime;

end
if f(i)>1.5*b && f(i)<=2*b
term1(j)=term1(j)+gamma_us/2*(1-cos(2*pi*f(i)/b))*a_prime;

end


i=i+1;
end

j=j+1;
i=1;
end

%dislocation displacement
u=0:0.0005*b:b;
u=transpose(u);


%plot misfit vs. displacement (Max derivative gives the PN stress)
plot(term1)

%calculate PN
PN_Stress_MPa = max(abs(1/b * diff (term1)./diff(u)))*10



